require "math"

function render(time)
    local config = getEntityById("Config")
    local inputTexture = getEntityById("InputTexture")
    local maskTexture = getEntityById("maskTexture")

    local lightingParameters = getEntityById("lightingParameters")
    local modelView = getEntityById("modelView")
    local modelViewProjection = getEntityById("modelViewProjection")
    local shaderPass1 = getEntityById("ShaderPass1")

    local material1 = shaderPass1.getMaterial()
    local materialParameters = {0.0,2.0,0.1,6.0}
    local poiNum = getEntityById("poiNum")

    material1.setVec4("u_LightingParameters",lightingParameters.x,lightingParameters.y,lightingParameters.z,lightingParameters.w)
    material1.setVec4("u_MaterialParameters",0.0,2.0,0.1,6.0)
    material1.setMat4("u_ModelView",modelView)
    material1.setMat4("u_ModelViewProjection",modelViewProjection)

    local wingImage = getEntityById("wingsImage")
    if wingId == nil then
        wingId = wingImage.getTextureAtTime(time - config.startTime)
    else
        wingId = wingImage.getTextureAtTimeReuse(time - config.startTime, wingId)
    end

     shaderPass1.setOutputTextureSize(config.outputWidth, config.outputHeight)
     shaderPass1.setInputTexture("u_Texture", wingId)
     shaderPass1.render3d()

    local shaderPass0 = getEntityById("ShaderPass0")
    local material0 = shaderPass0.getMaterial()
    material0.setFloat("poiNum",poiNum)

    shaderPass0.setOutputTextureSize(config.outputWidth, config.outputHeight)
    shaderPass0.setInputTexture("inputTexture", inputTexture)
    shaderPass0.setInputTexture("maskTexture", maskTexture)
    shaderPass0.setInputTexture("wingsTexture", shaderPass1.getOutputTexture())
    shaderPass0.render()

    return shaderPass0.getOutputTexture()
end