precision highp float;
varying vec2 textureCoordinate;
uniform sampler2D inputTexture;
uniform sampler2D maskTexture;
uniform sampler2D wingsTexture;
uniform float poiNum;

void main() {
    vec4 color_base = texture2D(inputTexture, textureCoordinate);
    vec4 color_mask = texture2D(maskTexture, vec2(textureCoordinate.x,1.0 - textureCoordinate.y));
    vec4 color_wings = texture2D(wingsTexture, textureCoordinate);

    vec4 baseColor = color_base * (1.0 - color_wings.a) + color_wings;
    vec4 fgColor = vec4(color_base.rgb,color_mask.r);
    if (poiNum > 0.0)
    {
        gl_FragColor = vec4(baseColor.rgb * (1.0 - fgColor.a) + fgColor.rgb * fgColor.a,baseColor.a);
    } else
    {
        gl_FragColor = baseColor;
    }
}

