uniform mat4 u_ModelView;
uniform mat4 u_ModelViewProjection;

attribute vec4 aPosition;
attribute vec3 aNormal;
attribute vec4 aTextureCoord;

varying vec3 v_ViewPosition;
varying vec3 v_ViewNormal;
varying vec2 v_TexCoord;

void main() {
     v_ViewPosition = (u_ModelView * aPosition).xyz;
     v_ViewNormal = (u_ModelView * vec4(aNormal.xyz, 0.0)).xyz;
     v_TexCoord = aTextureCoord.xy;
     gl_Position = u_ModelViewProjection * aPosition;
}
